
{

      Demonstran program pouit knihovny TUSB1052 s moduly MicroUnit.


   Program demonstruje voln jednotlivch funkc knihovny TUSB1052 pro
   komunikaci s modulem MicroUnit pes modul USB-1052. Pro pouit knihovny
   je nutn znalost modulu MicroUnit v rozsahu jeho Uivatelsk pruky.
   Knihovnu nen nutno samostatn instalovat, sta ji v rmci instalace
   aplikanho software pouze pekoprovat do msta, kam bude mt aplikan
   program nastavenu cestu.


  Poznmka:
   Pro jednoduchost a nzornost pouit je omezeno oeten chyb, kter mohou
   za bhu programu nastat.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, TUSB1052, ExtCtrls;

const
  cAdresaMU = 1;                // adresa pipojenho modulu MicroUnit
  cBaudMU = 9600;               // rychlost pipojenho modulu MicroUnit

type
  TForm1 = class(TForm)
    Button2: TButton;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Timer1: TTimer;
    Label11: TLabel;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1     : TForm1;      // dialogov okno programu

  HNDL      : DWord;       // handle otevenho zazen

                           // konfiguran data knihovny
  Baud      : DWord;       // komunikan rychlost modulu MicroUnit, platn
                           // hodnoty : 600, 1200, 2400, 4800, 9600, 19200,
                           // 38400, 57600 a 115200 Bd
  Timeout   : DWord;       // timeout odpovdi modulu, platn hodnoty 1-10000ms
  Opakovani : DWord;       // poet opakovn voln na modul MicroUnit
                           // v ppad chybn komunikace

  BuffT     : TBuff;       // vyslac buffer, obsahuje data vyslan na modul
                           // MicroUnit (pole DWord)
  BuffR     : TBuff;       // pijmac buffer, obsahuje pijat data z modulu
                           // MicroUnit (pole DWord)
  StatusR   : DWord;       // pijat Status registr modulu MicroUnit
  StatusP   : DWord;       // status pjmu - komunikace s modulem MicroUnit

  Chyba     : DWord;       // chybov kd
  TextChyby : TBuff;       // slovn vyjden chybovho kdu

  Otevreno  : boolean;     // pomocn promenn signalizujc oteven knihovny

  DOUT      : cardinal;    // zapisovan hodnota na digitln vstupy


implementation

{$R *.dfm}


//______________________________________________________________________________ Pomocn funkce


//____________________________________________________ Pevod hodnoty Cardinal _
// Funkce pro pevod pijat zprvy na selnou hodnotu. Vstupem jsou pijat
// datov byty odpovdi modulu MicroUnit, vstupem je spotan cardinal hodnota.

Function PrevodBytesCardinal(B1,B2,B3,B4:byte) : cardinal;
var
  C1 : cardinal;
begin
  C1:=B4;
  C1:=C1*256+B3;
  C1:=C1*256+B2;
  C1:=C1*256+B1;
  Result:=C1;
end;

//____________________________________________________ Pevod hodnoty LongReal _
// Funkce pro pevod pijat zprvy na hodnotu real. Vstupem jsou pijat
// datov byty odpovdi modulu MicroUnit, vstupem je spotan real hodnota.

Function PrevodBytesReal(B1,B2,B3,B4:byte) : double;
var
  I,Exp : byte;
  R     : double;
begin
  R:=(B3 and $7F)*1.0;
  R:=(R*256.0+B2)*256.0+B1;
  if B3>127 then R:=-R;
  Exp:=B4 and $7F;
  if Exp>0 then
    for I:=1 to Exp do R:=R/10.0;
  Result:=R;
end;

//_______________________________________________________ Pevod hodnoty Binar _
// Funkce pro pevod pijat zprvy na bitov pole. Vstupem jsou pijat
// datov byty odpovdi modulu MicroUnit, vstupem je string bitovho pole.

Function PrevodBytesBinar(B1,B2,B3,B4:byte) : string;
var
  S : string;
begin
  S:='00000000 00000000 00000000 00000000';

  if ((B4 and $80)>0) then S[1]:='1';
  if ((B4 and $40)>0) then S[2]:='1';
  if ((B4 and $20)>0) then S[3]:='1';
  if ((B4 and $10)>0) then S[4]:='1';
  if ((B4 and $08)>0) then S[5]:='1';
  if ((B4 and $04)>0) then S[6]:='1';
  if ((B4 and $02)>0) then S[7]:='1';
  if ((B4 and $01)>0) then S[8]:='1';

  if ((B3 and $80)>0) then S[10]:='1';
  if ((B3 and $40)>0) then S[11]:='1';
  if ((B3 and $20)>0) then S[12]:='1';
  if ((B3 and $10)>0) then S[13]:='1';
  if ((B3 and $08)>0) then S[14]:='1';
  if ((B3 and $04)>0) then S[15]:='1';
  if ((B3 and $02)>0) then S[16]:='1';
  if ((B3 and $01)>0) then S[17]:='1';

  if ((B2 and $80)>0) then S[19]:='1';
  if ((B2 and $40)>0) then S[20]:='1';
  if ((B2 and $20)>0) then S[21]:='1';
  if ((B2 and $10)>0) then S[22]:='1';
  if ((B2 and $08)>0) then S[23]:='1';
  if ((B2 and $04)>0) then S[24]:='1';
  if ((B2 and $02)>0) then S[25]:='1';
  if ((B2 and $01)>0) then S[26]:='1';

  if ((B1 and $80)>0) then S[28]:='1';
  if ((B1 and $40)>0) then S[29]:='1';
  if ((B1 and $20)>0) then S[30]:='1';
  if ((B1 and $10)>0) then S[31]:='1';
  if ((B1 and $08)>0) then S[32]:='1';
  if ((B1 and $04)>0) then S[33]:='1';
  if ((B1 and $02)>0) then S[34]:='1';
  if ((B1 and $01)>0) then S[35]:='1';

  Result:=S;
end;

//_______________________________________________________ Pevod hodnoty ASCII _
// Funkce pro pevod pijat zprvy na ASCII string. Vstupem jsou pijat
// datov byty odpovdi modulu MicroUnit, vstupem je ASCII string.

Function PrevodBytesASCII(B1,B2,B3,B4:byte) : string;
var
  S : string;
begin
  S:='';
  S:=S+chr(B1);
  S:=S+chr(B2);
  S:=S+chr(B3);
  S:=S+chr(B4);
  Result:=S;
end;

//______________________________________________________ Pevod pole na string _
// Funkce pro pevod pole typu Buff na string. Vstupem je text ve form pole
// bytu, vstupem je text ve form stringu.

function BuffToStr(B:TBuff):string;
var
  S : string;
  I : integer;
begin
  I:=0;
  repeat
    if (B[I]<>0) then S:=S+chr(B[I]);
    inc(I);
  until ((I>99) or (B[I]=0));
  Result:=S;
end;

//______________________________________________________________________________ Start programu

// Inicializace zazen. Funkce TUSB1052_Init se provd vdy na zatku
// innosti se zazenm. Parametrem je ukazatel na DWord, ve kterm funkce
// vrac handle pidlen zazen.
// Zpis konfiguranch dat knihovny. Pomoc funkce TUSB1052_SetConfig jsou
// do knihovny zapsny konfiguran data. Parametry jsou handle zazen (HNDL),
// komunikan rychlost (Baud), timeout odpovdi modulu MicroUnit (Timeout) a
// poet opakovn voln (Opakovani), ve typu DWord.

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label2.Caption:='';
  Label7.Caption:='';
  Label8.Caption:='';
  Label9.Caption:='';
  Label10.Caption:='';
  Label11.Caption:='';             // nastaven okna

  Otevreno:=false;                 // zazen zatm neoteveno
  DOUT:=1;                         // poten hodnota digitlnch vstup

  Chyba:=TUSB1052_Init(@HNDL);
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;         // konec inicializace knihovny

  Baud:=cBaudMU;                   // volba komunikan rychlosti
  Timeout:=200;                    // timeout [ms] odpovdi modulu
  Opakovani:=2;                    // poet opakovn voln pi chyb
  Chyba:=TUSB1052_SetConfig(HNDL,Baud,Timeout,Opakovani);
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);

  Otevreno:=true;                  // zazen oteveno
end;

//______________________________________________________________________________ Konec programu

// Uzaven zazen. Funkc TUSB1052_Done se uzavr oteven zazen.
// Parametrem je ukazatel na handle zazen (DWord).

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=false;
  if Otevreno then                      // otevenou knihovnu zavt
    begin
      Otevreno:=false;
      TUSB1052_Done(@HNDL);
    end;
end;

//______________________________________________________________________________ Tl. Konec

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

//______________________________________________________________________________ asova

// Komunikace s modulem MicroUnit. Po oteven a ppadnm nastaven
// konfiguranch dat probh komunikace s moduly MicroUnit pomoc funkce
// TUSB1052_Send. Parametry funkce jsou handle zazen (HNDL, typ DWord),
// vyslan data do modulu MicroUnit (BuffT, typ ukazatel na pole DWord),
// data pijat z modulu MicroUnit (BuffR, typ ukazatel na pole DWord),
// pijat Status registr modulu MicroUnit (StatusR, typ ukazatel na DWord)
// a status pijmu jako vsledek komunikace s modulem MicroUnit (StatusP,
// typ ukazatel na DWord).

procedure TForm1.Timer1Timer(Sender: TObject);
var
  D : cardinal;
  B1,B2,B3,B4 : byte;
begin
  if (not Otevreno) then Exit;          // test oteven zazen





//-----------------  Funkce 0 / Periferie 0 (pklad ten periferie typu REAL)

// naplnn vyslacho bufferu - TBuff[0..7]
  BuffT[0]:=cAdresaMU;                   // adresa modulu MicroUnit (0-255)
  BuffT[1]:=0;                           // poadovan funkce AIBus-2 (ten)
  BuffT[2]:=0;                           // periferie modulu MicroUnit
  BuffT[3]:=0;                           // pkaz
  BuffT[4]:=0;                           // D1
  BuffT[5]:=0;                           // D2 data zapisovan do periferie
  BuffT[6]:=0;                           // D3
  BuffT[7]:=0;                           // D4

  Chyba:=TUSB1052_Send(HNDL,@BuffT,@BuffR,@StatusR,@StatusP);

// vyhodnocen chyby voln funkce TUSB1052_Send
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;

// vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  TUSB1052_Error(StatusP,@TextChyby);
  Label2.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
  if (StatusP<>0) then Exit;

// vpis pijatch dat
  Label7.Caption:=FloatToStrF(PrevodBytesReal(BuffR[0],BuffR[1],BuffR[2],BuffR[3]),ffFixed,5,BuffR[3] and $7F);




//---------  Funkce 0 / Periferie 64 (pklad ten periferie typu BITOVE POLE)

// naplnn vyslacho bufferu - TBuff[0..7]
  BuffT[0]:=cAdresaMU;                   // adresa modulu MicroUnit (0-255)
  BuffT[1]:=0;                           // poadovan funkce AIBus-2 (ten)
  BuffT[2]:=64;                          // periferie modulu MicroUnit
  BuffT[3]:=0;                           // pkaz
  BuffT[4]:=0;                           // D1
  BuffT[5]:=0;                           // D2 data zapisovan do periferie
  BuffT[6]:=0;                           // D3
  BuffT[7]:=0;                           // D4

  Chyba:=TUSB1052_Send(HNDL,@BuffT,@BuffR,@StatusR,@StatusP);

// vyhodnocen chyby voln funkce TUSB1052_Send
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;

// vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  TUSB1052_Error(StatusP,@TextChyby);
  Label2.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
  if (StatusP<>0) then Exit;

// vpis pijatch dat
  Label8.Caption:=PrevodBytesBinar(BuffR[0],BuffR[1],BuffR[2],BuffR[3]);




//------------  Funkce 0 / Periferie 80 (pklad ten periferie typu CARDINAL)

// naplnn vyslacho bufferu - TBuff[0..7]
  BuffT[0]:=cAdresaMU;                   // adresa modulu MicroUnit (0-255)
  BuffT[1]:=0;                           // poadovan funkce AIBus-2 (ten)
  BuffT[2]:=80;                          // periferie modulu MicroUnit
  BuffT[3]:=0;                           // pkaz
  BuffT[4]:=0;                           // D1
  BuffT[5]:=0;                           // D2 data zapisovan do periferie
  BuffT[6]:=0;                           // D3
  BuffT[7]:=0;                           // D4

  Chyba:=TUSB1052_Send(HNDL,@BuffT,@BuffR,@StatusR,@StatusP);

// vyhodnocen chyby voln funkce TUSB1052_Send
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;

// vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  TUSB1052_Error(StatusP,@TextChyby);
  Label2.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
  if (StatusP<>0) then Exit;

// vpis pijatch dat
  Label9.Caption:=IntToStr(PrevodBytesCardinal(BuffR[0],BuffR[1],BuffR[2],BuffR[3]));




//--------------  Funkce 200 / Periferie 0 (pklad ten periferie typu ASCII)

// naplnn vyslacho bufferu - TBuff[0..7]
  BuffT[0]:=cAdresaMU;                   // adresa modulu MicroUnit (0-255)
  BuffT[1]:=200;                         // poadovan funkce AIBus-2 (ten)
  BuffT[2]:=0;                           // periferie modulu MicroUnit
  BuffT[3]:=0;                           // pkaz
  BuffT[4]:=0;                           // D1
  BuffT[5]:=0;                           // D2 data zapisovan do periferie
  BuffT[6]:=0;                           // D3
  BuffT[7]:=0;                           // D4

  Chyba:=TUSB1052_Send(HNDL,@BuffT,@BuffR,@StatusR,@StatusP);

// vyhodnocen chyby voln funkce TUSB1052_Send
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;

// vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  TUSB1052_Error(StatusP,@TextChyby);
  Label2.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
  if (StatusP<>0) then Exit;

// vpis pijatch dat
  Label10.Caption:=PrevodBytesASCII(BuffR[0],BuffR[1],BuffR[2],BuffR[3]);




//-----  Funkce 1 / Periferie 64 (pklad zpisu na periferii typu BITOVE POLE)

  D:=DOUT;
  B1:=D mod 256; D:=D div 256;
  B2:=D mod 256; D:=D div 256;
  B3:=D mod 256; D:=D div 256;
  B4:=D mod 256;

// naplnn vyslacho bufferu - TBuff[0..7]
  BuffT[0]:=cAdresaMU;                   // adresa modulu MicroUnit (0-255)
  BuffT[1]:=1;                           // poadovan funkce AIBus-2 (zpis)
  BuffT[2]:=64;                          // periferie modulu MicroUnit
  BuffT[3]:=0;                           // pkaz
  BuffT[4]:=B1;                          // D1
  BuffT[5]:=B2;                          // D2 data zapisovan do periferie
  BuffT[6]:=B3;                          // D3
  BuffT[7]:=B4;                          // D4

  Chyba:=TUSB1052_Send(HNDL,@BuffT,@BuffR,@StatusR,@StatusP);

// vyhodnocen chyby voln funkce TUSB1052_Send
  TUSB1052_Error(Chyba,@TextChyby);
  StatusBar1.Panels[1].Text:=IntToStr(Chyba)+' - '+BuffToStr(TextChyby);
  if (Chyba<>0) then Exit;

// vyhodnocen chyby komunikace s modulem MicroUnit - StatusP
  TUSB1052_Error(StatusP,@TextChyby);
  Label2.Caption:=IntToStr(StatusP)+' - '+BuffToStr(TextChyby);
  if (StatusP<>0) then Exit;

// vpis vyslanch dat
  Label11.Caption:=PrevodBytesBinar(B1,B2,B3,B4);

// nov vyslan data
  DOUT:=DOUT*2; if (DOUT=0) then DOUT:=1;

end;
//______________________________________________________________________________

end.
